<?php
/********************************************************************
This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
********************************************************************/
// custom handler
function eh($type, $msg, $file, $line)
{
// log all errors
print "WARNING (@$line) =======>$msg \n";

}

// report all errors
error_reporting(E_ALL);
// define custom handler
set_error_handler("eh");

print "NOTE: WARNINGs are messages for developers, it may not affect the running of the agent. But you are required to report it when you contact for support.\n\n";

set_time_limit(0);
// ------- scrtips start --------
$igmail_server = "http://igmail.idemfactor.com/ppush.php";
$SLEEP_SECONDS = 30; // NOTE: DO NOT set it too small, or Gmail may lock your IMAP access due to improper use. If that happened, please visit http://igmail.idemfactor.com/faq.html for unlock instructions.
$ini_file = "igmail.ini";
$raw_ini = parse_ini_file($ini_file);
$ini=isset($raw_ini['settings'])?$raw_ini['settings']:$raw_ini; // igmail.ini has a [settings] section to be compatible with windows agent, php agent just ignore it
$email = $ini['email'];
$password = $ini['password'];
if (empty($password) || strstr($password, '***')) 
	die("Invalid password [$password]. Please make sure you've specified a correct password in igmail.ini file.");
$txid = $ini['receipt'];
$filter = isset($ini['filter'])?$ini['filter']:'';
$last_badge = isset($ini['last_badge'])?$ini['last_badge']:0;
$clear_badge = isset($ini['clear_badge'])?$ini['clear_badge']:10;
$last_mail = isset($ini['last_mail'])?$ini['last_mail']:0;
if ($last_mail>1000000000)
	$last_mail=0; // for upgrade compatibility
print "Current Receipt is $txid\n";

$label = isset($ini['label'])?$ini['label']:'INBOX';
$imap_server = "{imap.gmail.com:993/ssl/novalidate-cert/readonly}$label";
print "IMAP URL=$imap_server\n";

if (!isset($ini['alert_type']))
	$ini['alert_type'] = 'ss';
$isSStype = $ini['alert_type']=='ss';
if (!isset($ini['alert_sound']))
	$ini['alert_sound'] = 'default';
$sound = $ini['alert_sound'];

if (!isset($ini['quiet_from']))
	$ini['quiet_from'] = '23:00';
if (!isset($ini['quiet_to']))
	$ini['quiet_to'] = '07:30';
$dfstr = substr($ini['quiet_from'],0,5);
$dfstr = str_replace('24:','00:',$dfstr);
$dtstr = substr($ini['quiet_to'],0,5);
$dtstr = str_replace('24:','00:',$dtstr);

$pattern = "/^\\d\\d:\\d\\d$/";
if (preg_match($pattern, $dfstr)==0 || preg_match($pattern, $dtstr)==0)
	die("Invalid quiet time, must use HH:MM format such as 00:30. If you want to disable it, simply use the same value for 'quiet_from' and 'quiet_to'.\n");


  function do_post_request($postdata, $optional_headers = 'Content-type: application/x-www-form-urlencoded')
  {
	global $igmail_server;
	$opts = array('http' =>
	    array(
       		 'method'  => 'POST',
       		 'header'  => $optional_headers,
       		 'content' => $postdata
    		)
	);
	$context  = stream_context_create($opts);
	$result = file_get_contents($igmail_server, false, $context);
 
	return $result;
  }

  function pushIt($msg, $badge, $ringtone)
  {
	global $ini, $ini_file, $email, $txid, $filter;
	$post = "email=".rawurlencode($email)."&txid=$txid&igmail=iGmail";
	if ($filter=="" || strstr($filter, $email)) {
		if (isset($msg)) $post .= "&msg=".rawurlencode($msg);
		if (isset($ringtone)) $post .= "&ringtone=$ringtone";
	}
	if (isset($badge)) $post .= "&badge=$badge";
	do_post_request($post);
	write_ini_file($ini, $ini_file);
  }

    function write_ini_file($assoc_arr, $path, $has_sections=FALSE) {
        $content = "";

        if ($has_sections) {
            foreach ($assoc_arr as $key=>$elem) {
                $content .= "[".$key."]\n";
                foreach ($elem as $key2=>$elem2) {
                    $content .= $key2." = \"".$elem2."\"\n";
                }
            }
        }
        else {
            foreach ($assoc_arr as $key=>$elem) {
                $content .= $key." = \"".$elem."\"\n";
            }
        }

        if (!$handle = fopen($path, 'w')) {
            return false;
        }
        if (!fwrite($handle, $content)) {
            return false;
        }
        fclose($handle);
        return true;
    }

// --- use config file ---

$connection = null;
while (true)
{
  sleep($SLEEP_SECONDS);

  $curtime = date('H:i');
  $quiet = false;
  if ($dfstr>$dtstr) {
    if ($curtime>$dfstr || $curtime<$dtstr)
                $quiet = true;
  } else {
    if ($dfstr<$curtime && $curtime<$dtstr)
                $quiet = true;
  }

// --- open IMAP connection ---
  if (empty($connection)) {
	print "start to monitor Gmail account: $email\n";
	$connection = imap_open($imap_server, $email, $password);
  }
  if (!$connection) {
	$error = imap_last_error();
	if (strpos($error, 'simultaneous')!==false || strpos($error, 'broken')!==false || strpos($error, 'System Error')!==false)
	{
		print date("Y-m-d H:i:s").":IMAP ERROR:".imap_last_error()." - skipping...\n";
		continue; // try it later
	}
	print date("Y-m-d H:i:s").":FATAL IMAP ERROR:".imap_last_error()."\n";
	print "Please verify you have specified correct credentials in igmail.ini file, or visit http://igmail.idemfactor.com for instructions.";
	pushIt("Gmail agent on your computer has stopped working due to error: ".imap_last_error(), 0, $sound);
	break;
  }

  $check = imap_check($connection);
  if (empty($check)) {
        imap_close($connection);
        $connection = null;
        continue;
  }

  $msg_count = $check->Nmsgs; 
  // ------------ calc unread -------------
  $status = imap_status($connection,$imap_server,SA_UNSEEN);
  $badge = $status->unseen;

  $mail_num = 0;
  $last_mail_time = $last_mail;
  $push_msg = "";
  for($i = $msg_count; $i > 0 && $i > ($msg_count-10); $i--) {
    	$header = imap_fetch_overview($connection, $i);
	if (count($header)<=0) break;
	$issuedtime = $header[0]->uid; 
	if ($issuedtime <= $last_mail) break; // stop checking as no newer mails
	if ($last_mail_time < $issuedtime) $last_mail_time = $issuedtime; // store the latest time
	if (!$header[0]->seen) {
		$mail_num++;
		// now prepare notification objects
if (!$isSStype || $mail_num == 1) {
		if ($push_msg) $push_msg .= ";  ";
		$from = mb_substr($header[0]->from, 0, mb_strpos($header[0]->from, '<'));
		if (trim($from))
			$push_msg .= iconv_mime_decode($from,2,"UTF-8");
		else
			$push_msg .= $header[0]->from;
}
		if ($isSStype && $mail_num == 1) {
			//only read the latest mail for push
			$push_msg = "From: $push_msg||Subject: ".(empty($header[0]->subject)?"NO SUBJECT":iconv_mime_decode($header[0]->subject,2,"UTF-8")); 
			break;
		}
	}
  }



// ------------ push service ------------
  // Construct the notification payload
  if ($mail_num == 0 || $ini['alert_type']=='disabled')
	$push_msg=null;
  else {
  	if (!$isSStype)
		$push_msg = "You have $mail_num new mails!||---------- From: ----------||".$push_msg;
	// make sure the overall length is less than 180, so that it's less than 256 after json-encode
  	$push_msg = mb_substr($push_msg, 0, 180, "UTF-8");
  }


  if ($mail_num == 0) { 
	if ($badge != $last_badge && $last_badge>=0)// no new mail, but unread changed
		if ($clear_badge==10) 
			pushIt(null, 0, null); // clear badge when clear_badge is ON
		else
			pushIt(null, $badge, null); // update badge when clear_badge is OFF
  } else if ($quiet)
	pushIt(null, $badge, null);
  else
	pushIt($push_msg, $badge, $sound);

if ($last_badge>=0) {
	$ini['last_badge']=$badge;
  	$last_badge = $badge;
}

  $ini['last_mail']=$last_mail_time;
  $last_mail = $last_mail_time;


} // -- end of while

if ($connection) imap_close($connection);

?>
